package za.org.treehouse.hypoalarm;

import android.app.Activity;
import android.app.AlarmManager;
import android.app.PendingIntent;
import android.content.Context;
import android.content.Intent;
import android.os.Bundle;
import android.os.PowerManager;
import android.os.Vibrator;
import android.util.Log;
import android.view.View;
import android.view.Window;
import android.view.WindowManager;
import android.widget.Button;

import java.util.Timer;
import java.util.TimerTask;

// TODO See GlowPad.

public class AlarmAlertActivity extends Activity {
    // TODO correct life
    static int ALERT_LIFE = 1000*10;//1000*60*2; // 2 minutes
    private Timer timer;
    private PowerManager.WakeLock fullWl;
    private AlarmManager graceManager;
    private PendingIntent gracePendingIntent;
    private Vibrator vibrator;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.alarm_alert);

        // Disable any current notifications
        this.stopService(new Intent(getApplicationContext(), AlarmNotify.class));

        Window window = getWindow();
        window.addFlags(WindowManager.LayoutParams.FLAG_SHOW_WHEN_LOCKED |
            WindowManager.LayoutParams.FLAG_KEEP_SCREEN_ON |
            WindowManager.LayoutParams.FLAG_TURN_SCREEN_ON );

        // Turn off the alert activity, and switch to a notification
        timer = new Timer();
        timer.schedule(new TimerTask() {
            public void run() {
                // Switch to notification
                startService(new Intent(getApplicationContext(), AlarmNotify.class));
                finish();
                Log.d("AlarmAlertActivity", "Stopped AlarmAlertActivity");
            }
        }, ALERT_LIFE);
    }

    @Override
    public void onStart() {
        super.onStart();

        PowerManager pm = (PowerManager) getSystemService(Context.POWER_SERVICE);
        fullWl = pm.newWakeLock(PowerManager.PARTIAL_WAKE_LOCK
                | PowerManager.ACQUIRE_CAUSES_WAKEUP | PowerManager.ON_AFTER_RELEASE, "AlarmAlertActivity");
        fullWl.acquire();

        long[] pattern = {0, 1000, 1000};
        vibrator = (Vibrator) getSystemService(Context.VIBRATOR_SERVICE);
        vibrator.vibrate(pattern, 0);

        // TODO change button to slide...
        // TODO change slide to circle slide? https://github.com/JesusM/HoloCircleSeekBar
        Button cancelButton = (Button) findViewById(R.id.cancel_dialog_button);
        cancelButton.setOnClickListener (new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                graceManager = (AlarmManager) getSystemService(Context.ALARM_SERVICE);
                Intent graceIntent = new Intent(getApplicationContext(), GraceReceiver.class);
                gracePendingIntent = PendingIntent.getBroadcast(getApplicationContext(), MainActivity.GRACE_REQUEST, graceIntent, 0);
                graceManager.cancel(gracePendingIntent);
                Log.d("AlarmAlertActivity", "Cancelled grace alarm.");
                finish();
            }
        });
    }

    public void onStop() {
        timer.cancel();
        vibrator.cancel();
        fullWl.release();
        super.onStop();
    }

}