package za.org.treehouse.hypoalarm;

import android.app.AlarmManager;
import android.app.PendingIntent;
import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.content.SharedPreferences;
import android.preference.PreferenceManager;
import android.util.Log;

import java.util.Calendar;

public class BootReceiver extends BroadcastReceiver {
    SharedPreferences sharedPref;
    private AlarmManager alarmManager;
    private PendingIntent alarmIntent;

    @Override
    public void onReceive(Context context, Intent intent) {
        sharedPref = PreferenceManager.getDefaultSharedPreferences(context);
        if (intent.getAction().equals("android.intent.action.BOOT_COMPLETED")) {
            // Reset for tomorrow; as of API 19, setRepeating() is inexact, so we use setExact()
            String alarmTimeStr = sharedPref.getString(context.getString(R.string.AlarmTimePref), null);
            if (alarmTimeStr != null) {
                // If it's later than alarmTimeStr, Calendar automatically advances the day.
                Calendar cal = MainActivity.TimeStringToCalendar(alarmTimeStr);
                alarmManager = (AlarmManager) context.getSystemService(Context.ALARM_SERVICE);
                alarmIntent = PendingIntent.getBroadcast(context, 0, intent, 0);
                // TODO use set() for older APIs
                alarmManager.setExact(AlarmManager.RTC_WAKEUP, cal.getTimeInMillis(), alarmIntent);
                Log.d("BootReceiver", "Setting alarm for "+MainActivity.debugDate(cal));
            }
        }
    }
}
