package za.org.treehouse.hypoalarm;

import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.content.SharedPreferences;
import android.os.PowerManager;
import android.preference.PreferenceManager;
import android.telephony.SmsManager;
import android.util.Log;

public class GraceReceiver extends BroadcastReceiver {
    SharedPreferences sharedPref;

    @Override
    public void onReceive(Context context, Intent intent) {
        sharedPref = PreferenceManager.getDefaultSharedPreferences(context);
        Boolean alarmActive = sharedPref.getBoolean(context.getString(R.string.AlarmActivePref), true);

        if (alarmActive) {
            PowerManager pm = (PowerManager) context.getSystemService(Context.POWER_SERVICE);
            PowerManager.WakeLock partialWl = pm.newWakeLock(PowerManager.PARTIAL_WAKE_LOCK, "AlarmReceiver");
            partialWl.acquire();

            String phoneNumber = sharedPref.getString(context.getString(R.string.PhoneNumberPref), null);
            String message = sharedPref.getString(context.getString(R.string.MessagePref), null);

            SmsManager sms = SmsManager.getDefault();
            // TODO uncomment this:
            //sms.sendTextMessage(phoneNumber, null, message, null, null);
            Log.d("GraceReceiver", "Sending sms to " + phoneNumber);

            partialWl.release();
        }
    }
}
